# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


import re  # noqa: F401
import sys  # noqa: F401

from datadog_api_client.v1.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)


def lazy_import():
    from datadog_api_client.v1.model.slo_error_budget_remaining_data import SLOErrorBudgetRemainingData
    from datadog_api_client.v1.model.slo_history_response_error import SLOHistoryResponseError

    globals()["SLOErrorBudgetRemainingData"] = SLOErrorBudgetRemainingData
    globals()["SLOHistoryResponseError"] = SLOHistoryResponseError


class SLOHistorySLIData(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {}

    validations = {}

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            "error_budget_remaining": (SLOErrorBudgetRemainingData,),  # noqa: E501
            "errors": ([SLOHistoryResponseError],),  # noqa: E501
            "group": (str,),  # noqa: E501
            "history": ([[float]],),  # noqa: E501
            "monitor_modified": (int,),  # noqa: E501
            "monitor_type": (str,),  # noqa: E501
            "name": (str,),  # noqa: E501
            "precision": ({str: (float,)},),  # noqa: E501
            "preview": (bool,),  # noqa: E501
            "sli_value": (float,),  # noqa: E501
            "span_precision": (float,),  # noqa: E501
            "uptime": (float,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None

    attribute_map = {
        "error_budget_remaining": "error_budget_remaining",  # noqa: E501
        "errors": "errors",  # noqa: E501
        "group": "group",  # noqa: E501
        "history": "history",  # noqa: E501
        "monitor_modified": "monitor_modified",  # noqa: E501
        "monitor_type": "monitor_type",  # noqa: E501
        "name": "name",  # noqa: E501
        "precision": "precision",  # noqa: E501
        "preview": "preview",  # noqa: E501
        "sli_value": "sli_value",  # noqa: E501
        "span_precision": "span_precision",  # noqa: E501
        "uptime": "uptime",  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set(
        [
            "_data_store",
            "_check_type",
            "_spec_property_naming",
            "_path_to_item",
            "_configuration",
            "_visited_composed_classes",
        ]
    )

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """SLOHistorySLIData - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            error_budget_remaining (SLOErrorBudgetRemainingData): [optional]  # noqa: E501
            errors ([SLOHistoryResponseError]): A list of errors while querying the history data for the service level objective.. [optional]  # noqa: E501
            group (str): For groups in a grouped SLO, this is the group name.. [optional]  # noqa: E501
            history ([[float]]): For `monitor` based SLOs, this includes the aggregated history uptime time series.. [optional]  # noqa: E501
            monitor_modified (int): For `monitor` based SLOs, this is the last modified timestamp in epoch seconds of the monitor.. [optional]  # noqa: E501
            monitor_type (str): For `monitor` based SLOs, this describes the type of monitor.. [optional]  # noqa: E501
            name (str): For groups in a grouped SLO, this is the group name. For monitors in a multi-monitor SLO, this is the monitor name.. [optional]  # noqa: E501
            precision ({str: (float,)}): A mapping of threshold `timeframe` to number of accurate decimals, regardless of the from && to timestamp.. [optional]  # noqa: E501
            preview (bool): For `monitor` based SLOs, when `true` this indicates that a replay is in progress to give an accurate uptime calculation.. [optional]  # noqa: E501
            sli_value (float): The current SLI value of the SLO over the history window.. [optional]  # noqa: E501
            span_precision (float): The amount of decimal places the SLI value is accurate to for the given from `&&` to timestamp.. [optional]  # noqa: E501
            uptime (float): Use `sli_value` instead.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop("_check_type", True)
        _spec_property_naming = kwargs.pop("_spec_property_naming", False)
        _path_to_item = kwargs.pop("_path_to_item", ())
        _configuration = kwargs.pop("_configuration", None)
        _visited_composed_classes = kwargs.pop("_visited_composed_classes", ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments."
                % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if (
                var_name not in self.attribute_map
                and self._configuration is not None
                and self._configuration.discard_unknown_keys
                and self.additional_properties_type is None
            ):
                # discard variable.
                continue
            setattr(self, var_name, var_value)
